; LIFE/32 v.1.02  (C) Copr. T-Soft (Vasyl), 1993, 1996 All rights reserved.
; Compiled with TASM 3.1

; Programming style: classic spaghetti.

	MODEL small, c
	P386N
	LOCALS

	DATASEG

arrayP  dd 4 dup(?) ; Work array

Running dw 0
Change dw ?

Segs	dw 2 dup(?) ; Current field segment, prev field segment
LSeg	dw ?        ; Field shifted left segment
RSeg	dw ?        ; Field shifted right segment
SegEdit dw ?        ; Cut/paste buffer

IOSize   dw 0, 0    ; Picture size in i/o buffer (LSeg)
EditSize dw 0, 0    ; The same in edit buffer (SegEdit)


Zoom    dw 0

ZoomSize dw 512, 256, 128, 64, 32
ZoomProc dw 0, offset Z2Point, offset Z4Point, offset Z8Point, offset Z16Point

ZoomDef db 'none  x2  x4  x8 max'

ZoomDX  dw 0
ZoomDY  dw 0
Grid	dw 7
GSize	dw 8

GenNum	db '00000'

Str1    db 'Time'
Str2	db 'Zoom'
Str3    db 'Rect'
Str4	db 'L:   R:   T:   B:   '
Str5	db 'Crsr'
Str6	db 'X:   Y:   '
StrND	db '???'
Str7	db 'Ptrs'
Str8	db 'X1:   Y1:   X2:   Y2:   '

StrLife db 'LIFE  by   Vasyl Copr. 1993- 1996 v.1.02'

LowRAM  db 'Cannot allocate memory!', 10, 13, '$'
Not386  db '386 or better processor required!', 10, 13, '$'
NotVGA  db 'VGA adapter required!', 10, 13, '$'
NotMice db 'Microsoft compatible mouse required!', 10, 13, '$'
QuitMsg db 'Are you sure you want to quit? Press Y to confirm or N to cancel.'
GoMsg   db 'How many generations to go (1-9999) ?'
LoadMsg db 'File name to load: '
LoadTp  db 'Press R to replace or M to merge.'
SaveMsg db 'File name to save: '
FileError db 'File I/O error! Press any key to continue.'
NoFile  db 'Cannot find LIFE file! Press any key.'
CntMsg db 'Activity counter:'
SelectMsg db 'Select filename and press Return'

Where dw 004bh, 034bh, 064bh, 0000h, 0100h, 0200h, 0300h, 0400h, 0500h, 0600h
      dw 074ah, 084ah, 094ah, 0a4ah, 0c4bh, 0d4ah, 0e4ah, 0a00h, 0b00h, 0c00h
      dw 0d00h, 0e00h, 1103h, 1203h, 1303h
Len   dw 4,4,4,6,6,6,6,6,6,6,5,5,5,5,4,5,5,4,6,6,6,6,73,73,73
Off   dw offset Str1, offset Str2, offset Str3, offset StrLife
      dw offset StrLife+6, offset StrLife+12, offset StrLife+18
      dw offset StrLife+24, offset StrLife+30, offset StrLife+36
      dw offset Str4, offset Str4+5, offset Str4+10, offset Str4+15
      dw offset Str5, offset Str6, offset Str6+5, offset Str7
      dw offset Str8, offset Str8+6, offset Str8+12, offset Str8+18
      dw offset Menu, offset Menu+73, offset Menu+146


Z16data	db 00000000b, 00000000b
	db 00000001b, 11000000b
	db 00000111b, 11110000b
	db 00011111b, 11111100b
	db 00011111b, 11111100b
	db 00111111b, 11111110b
	db 00111111b, 11111110b
	db 01111111b, 11111111b
	db 01111111b, 11111111b
	db 01111111b, 11111111b
	db 00111111b, 11111110b
	db 00111111b, 11111110b
	db 00011111b, 11111100b
	db 00011111b, 11111100b
	db 00000111b, 11110000b
	db 00000001b, 11000000b


Z8data  db 00000000b
	db 00011100b
	db 00111110b
	db 01111111b
	db 01111111b
	db 01111111b
	db 00111110b
	db 00011100b

spBuff db 20 dup (?)
FName  db 10 dup (?)

Arrow db 10000000b, 00000000b
      db 11000000b, 00000000b
      db 11100000b, 00000000b
      db 11110000b, 00000000b
      db 11111000b, 00000000b
      db 11111100b, 00000000b
      db 11111110b, 00000000b
      db 11111111b, 00000000b
      db 11111000b, 00000000b
      db 10011000b, 00000000b
      db 00011000b, 00000000b
      db 00001100b, 00000000b
      db 00001100b, 00000000b
      db 00000110b, 00000000b
      
      
ArrowX dw 0
ArrowY dw 0
ArrowActive dw 0

Pointer db 00001000b, 0
	db 00001000b, 0
	db 00001000b, 0
	db 00001000b, 0
	db 00001000b, 0
	db 01111111b, 0
	db 00001000b, 0
	db 00001000b, 0
	db 00001000b, 0
	db 00001000b, 0
	db 00001000b, 0
	

PointerX dw 0, 511
PointerY dw 0, 255
LPtr	dw 0


Menu db 'Run       Zoom +    Zap       Flip =    Undo      Grid      Load      \', 24, '/'
     db 'Go        Zoom -    Fill      Flop |    Copy      Gen=0     Save      ', 27, '?', 26
     db 'Next      View x1   Invert    Rotate *  Paste     Center    Exit      /', 25, '\'

MenuUL dw 0, 15, 20, 35, 40, 53, 60 ; R+Z=UDL
       dw 0, 15, 20, 35, 40, 54, 60 ; G-F|C0S
       dw 0, 10, 20, 37, 40, 51, 61 ; NVI*PEX

MenuChar db 'R+Z=UDLG-F|C0SNVI*PEX'

MenuAcc db 3 dup (0)

	STACK 200h

	CODESEG

	STARTUPCODE
	mov bx, sp
	add bx, 15
	shr bx, 4
	mov ax, ss
	add bx, ax
	mov ax, es
	sub bx, ax
	mov ax, 4a00h
	int 21h
; If 80386
	pushf
	pushf
	pop ax
	or ax, 0f000h
	push ax
	popf
	pushf
	pop ax
	and ax, 0f000h
	jnz @@procok
	popf
	mov dx, offset Not386
	mov ax, 0900h
	int 21h
	jmp @@nohdw
@@procok:
	popf
; If VGA
	mov ax, 1a00h
	mov bx, 0010h
	int 10h
	cmp al, 1ah
	je @@vgaok
	mov dx, offset NotVGA
	mov ax, 0900h
	int 21h
	jmp @@nohdw		
@@vgaok:
; If mouse
	xor ax, ax
	int 33h
	cmp ax, 0ffffh
	je @@mouok
	mov dx, offset NotMice
	mov ax, 0900h
	int 21h
	jmp @@nohdw		
@@mouok:
; Allocate RAM
	mov ax, 4800h
	mov bx, 1024*5+5 ; 5 buffers 16k each and safety pool
	int 21h
	jnc @@amok
	mov ax, 0900h
	mov dx, offset LowRAM
	int 21h
	mov ax, 4c01h
	int 21h
@@amok:
	push ax
	mov [Segs], ax
	add ax, 1024
	mov [Segs+2], ax
	add ax, 1024
	mov [LSeg], ax
	add ax, 1024
	mov [RSeg], ax
	add ax, 1024
	mov [SegEdit], ax
; Clear first two buffers
	pop ax
	mov es, ax
	xor di, di
	mov cx, 8192
	cld
	xor eax, eax
	rep stosd

; Set graphics mode
	mov ax, 0fh
	int 10h
; Version 1.02 change
	mov ax, 1124h
	int 10h
; Prepare mouse
	mov ax, 7
	xor cx, cx
	mov dx, 631
	int 33h
	mov ax, 8
	xor cx, cx
	mov dx, 349
	int 33h
	mov ax, seg MouseHandler
	mov es, ax
	mov dx, offset MouseHandler
	mov cx, 011111b
	mov ax, 000ch
	int 33h

; Draw border
	mov ax, 0a000h
	mov es, ax
	mov bx, 7
@@dbloop1:
	mov byte ptr es:[bx], 1
	mov byte ptr es:[bx+65], 128
	add bx, 80
	cmp bx, 258*80
	jb @@dbloop1
	cld
	mov di, 8
	mov cx, 16
	mov eax, 0ffffffffh
	rep stosd
	mov di, 8+(257*80)
	mov cx, 16
	rep stosd
	
	push bp
	xor si, si
@@output:
	call Write, Where[si], Len[si], Off[si]
	inc si
	inc si
	cmp si, 50
	jne @@output
	
	mov ax, 0a000h
	mov es, ax
	mov bp, (17*16+13)*80+3
	xor si, si
	mov al, 0ffh
@@uloop:
	mov di, bp
	add di, MenuUL[si]
	mov es:[di], al
	inc si
	inc si
	cmp si, 14
	je @@nline
	cmp si, 28
	jne @@eloop
@@nline:
	add bp, 16*80
@@eloop:
	cmp si, 42
	jne @@uloop
	pop bp

	call GenNum0
	call ShowGenNum
	call ActivateArrow
	call MoveArrow, 320, 175
	call UpdateScreen
	call ShowPtrs
	call Start
; Set text mode
	mov ax, 0003h
	int 10h
; Release RAM
	mov ax, LSeg	; Computing segment of alocated chunk
	sub ax, 2048
	mov es, ax
	mov ax, 4900h
	int 21h
; Reset mouse
	xor ax, ax
	int 33h
@@nohdw:
	mov ax, 4c00h
	int 21h
	ret
	





PROC NextStep
USES es, eax, ebx, ecx, edx, si, di

	mov Change, 0
; Making left shifted field
	push ds
	mov ax, [Segs]
	mov es, ax
	mov ax, LSeg
	mov ds, ax
	mov bx, 16385
	clc
	dec bx
@@loopleft:
	jz @@doneleft
	dec bx
	dec bx
	dec bx
	dec bx
	mov eax, es:[bx]
	rcl eax, 1
	mov ds:[bx], eax
	jmp @@loopleft
@@doneleft:
	mov bx, 16380
	adc dword ptr ds:[bx], 0
	pop ds

; Making right shifted field
	push ds
	mov ax, RSeg
	mov ds, ax
	xor bx, bx
	mov cx, 4096
	clc
@@loopright:
	mov eax, es:[bx]
	rcr eax, 1
	mov ds:[bx], eax
	inc bx
	inc bx
	inc bx
	inc bx
	dec cx
	jnz @@loopright
	jnc @@doneright
	xor bx, bx
	or dword ptr ds:[bx], 080000000h
@@doneright:
	pop ds

; Doing main algorithm

	push bp
	xor bp, bp
@@mainloop:

; First step

	mov ax, Segs
	mov bx, LSeg
	mov cx, RSeg
	push ax
	push bx
	push cx
	pop es
	mov eax, es:[bp] ; Right[i]
	mov si, bp
	sub si, 64
	and si, 16383
	mov ebx, es:[si] ; Right[i-16]
	add si, 128
	and si, 16383
	mov ecx, es:[si] ; Right[i+16]
	pop es
	mov edx, es:[si] ; Left[i+16]
	mov esi, eax
	mov edi, ebx
	xor eax, ecx ; p1 xor p2 
	xor ebx, edx ; p3 xor p4
	and esi, ecx ; p1 and p2
	and edi, edx ; p3 and p4
	mov [arrayP+0], eax ; r01 = p1 xor p2
	mov [arrayP+4], esi ; r11 = p1 and p2
	mov [arrayP+8], ebx ; r03 = p3 xor p4
	mov [arrayP+12], edi ; r13 = p3 and p4
	mov eax, es:[bp] ;  Left[i]
	mov si, bp
	sub si, 64
	and si, 16383
	mov ebx, es:[si] ; Left[i-16]
	pop es
	mov ecx, es:[si] ; This[i-16]
	add si, 128
	and si, 16383
	mov edx, es:[si] ; This[i+16]
	mov esi, eax
	mov edi, ebx
	xor eax, ecx ; eax = r02 :p5 xor p6
	xor ebx, edx ; ebx = r04 :p7 xor p8
	and esi, ecx ; esi = r12 :p5 and p6
	and edi, edx ; edi = r14 :p7 and p8

; Second step

	mov ecx, [arrayP+0] ; ecx = r01
	xor [arrayP+0], eax ; arr0 = t01(r01^r02)
	and ecx, eax ; ecx = r01 and r02
	xor ecx, [arrayP+4] ; ecx ^= r11
	xor ecx, esi ; ecx = t11(r12^r11^(r01&r02))
	and esi, [arrayP+4] ; esi = t21(r12&r11)
	
	mov edx, [arrayP+8] ; ecx = r03
	xor [arrayP+8], ebx ; arr8 = t02(r03^r04)
	and edx, ebx
	xor edx, [arrayP+12]
	xor edx, edi ; edx = t12(r14^r13^(r04&r03))
	and edi, [arrayP+12] ; edi = t22(r14&r13)

; Third step

; Here: arrayP[0] = t01, arrayP[8] = t02,
;	ecx = t11, edx = t12, esi = t21, edi = t22
	mov ebx, es:[bp]
	mov ax, [Segs+2]
	mov es, ax  ; 'That' segment
	push ebx
	mov es:[bp], ebx
	mov eax, [arrayP+0]	; eax = t01
	mov ebx, [arrayP+8]	; ebx = t02
	push eax
	xor eax, ebx		; eax = q0
	or es:[bp], eax
	pop eax			;
	and eax, ebx		; eax = s2
	mov ebx, ecx		
	xor ebx, edx		; ebx = s1
	push eax		
	xor eax, ebx		; eax = q1
	and es:[bp], eax
	pop eax
	and eax, ebx		; eax = s1 and s2
	and ecx, edx
	or eax, ecx		; eax = 2nd subex of q2
	xor eax, esi
	xor eax, edi		; eax = q2
	not eax
	and es:[bp], eax	; set new value
	pop eax
	cmp eax, es:[bp]	; comparing with old	

; Throwing on-screen

	je @@nodraw
	mov Change, 1
	test Zoom, 0ffffh
	je @@drawasusual
	call SpecDraw, bp
	jmp @@nodraw
@@drawasusual:
	mov eax, es:[bp]	
	mov bx, 0a000h
	mov es, bx
	mov si, bp
	shr si, 6
	shl si, 4
	mov bx, si
	shl bx, 2
	add si, bx
	mov bx, bp
	and bx, 3ch
	add si, bx
	add si, 88

	rol eax, 8
	xchg ah, al
	rol eax, 16
	xchg ah, al
	rol eax, 8

	mov dword ptr es:[si], eax
@@nodraw:

	inc bp
	inc bp
	inc bp
	inc bp
	cmp bp, 16384
	jne @@mainloop
	pop bp

; That's all
	mov eax, dword ptr [Segs]
	rol eax, 16
	mov dword ptr [Segs], eax
@@nsdonot:
	ret

ENDP NextStep






PROC SpecDraw
USES es, eax, ebx, ecx, edx, si, di
ARG offs:word
	
	test Zoom, 0ffffh
	je @@sddonot
	mov ax, [Segs+2]
	mov es, ax
	mov si, offs
	mov eax, es:[si]
	mov bx, offs
	shr bx, 6
	mov dx, offs
	shl dx, 3
	and dx, 511
	mov cx, bx
	sub cx, ZoomDY
	jl @@sddonot
	mov si, Zoom
	shl si, 1
	shl cx, 1
	add si, offset ZoomSize
	cmp cx, ds:[si]
	jge @@sddonot
	mov cx, dx
	sub cx, ZoomDX
	jge @@sdpos
	mov dx, ZoomDX
	add cx, 31
	jl @@sddonot
	jmp @@sdgo
@@sdpos:
	cmp cx, ds:[si]
	jge @@sddonot
	push dx
	mov dx, ds:[si]
	dec dx
	sub dx, cx
	mov cx, dx
	pop dx
	cmp cx, 31
	jg @@sdgoall
	rol eax, cl
	rol eax, 1
	jmp @@sdgo
@@sdgoall:
	mov cx, 31
@@sdgo:
	mov si, offset ZoomProc
	add si, Zoom
	add si, Zoom
@@zl:
	mov edi, eax
	shr edi, cl
	and edi, 1

	call ds:[si], dx, bx, di
	
	inc dx
	sub cx, 1
	jge @@zl

@@sddonot:
	ret
	
ENDP SpecDraw





PROC Write
USES es, ax, bx, cx, dx, si, di
ARG coord:word, slen:word, soff:word

	mov ax, @data
	mov es, ax
	mov cx, slen
	mov bx, 000fh
	mov dx, coord
	mov ax, 1300h
	push bp
	mov bp, soff
	int 10h
	pop bp
	ret
	
ENDP Write





PROC UpdateScreen
USES es, eax, bx, cx, dx, si, di

	call PtrsOff
	call DeactivateArrow
	
	test Zoom, 0ffffh
	je @@usregular
	
	rol dword ptr Segs, 16
	xor cx, cx
@@uszloop:
	call SpecDraw, cx
	add cx, 4
	cmp cx, 16384
	jne @@uszloop
	rol dword ptr Segs, 16
	jmp @@usdonot
		
@@usregular:
	cld
	mov ax, [Segs]
	push ds
	mov ds, ax
	mov ax, 0a000h
	mov es, ax

	xor dx, dx
	mov bx, 88
@@loopupd:
	mov si, dx
	mov di, bx
	mov cx, 16
@@reploop:
	lodsd
	rol eax, 8
	xchg ah, al
	rol eax, 16
	xchg ah, al
	rol eax, 8
	stosd
	dec cx
	jne @@reploop
	add dx, 64
	add bx, 80
	cmp dx, 16384
	jb @@loopupd
	pop ds
@@usdonot:
	mov ax, Zoom
	shl ax, 2
	add ax, offset ZoomDef
	call Write, 044bh, 4, ax
	mov ax, ZoomDX
	call ShowPos, 074ch, 3, ax
	mov si, Zoom
	shl si, 1
	add ax, ZoomSize[si]
	dec ax
	call ShowPos, 084ch, 3, ax
	mov ax, ZoomDY
	call ShowPos, 094ch, 3, ax
	mov bx, ZoomSize[si]
	shr bx, 1
	add ax, bx
	dec ax
	call ShowPos, 0a4ch, 3, ax
	
	call ActivateArrow
	call PtrsOn
	call MoveArrow, ArrowX, ArrowY
	ret

ENDP UpdateScreen






PROC ShowPos
USES ax, bx, dx, di
ARG pos:word, slen:word, val:word

	mov ax, val
	mov bx, 10
	mov di, 4
@@sploop:
	xor dx, dx
	div bx
	add dl, 30h
	mov spBuff[di], dl
	sub di, 1
	jge @@sploop

	mov ax, (offset spBuff)+5
	sub ax, slen
	call Write, pos, slen, ax
	ret

ENDP ShowPos



PROC ShowDWord
USES eax, ebx, edx, di
ARG pos:word, slen:word, val:dword

	mov eax, val
	mov ebx, 10
	mov di, 9
@@sploop:
	xor edx, edx
	div ebx
	add dl, 30h
	mov spBuff[di], dl
	sub di, 1
	jge @@sploop

	mov ax, (offset spBuff)+10
	sub ax, slen
	call Write, pos, slen, ax
	ret

ENDP ShowDWord






PROC PutPoint
USES es, ax, cx, di
ARG x:word, y:word, val:word

	push es
	mov ax, [Segs]
	mov es, ax
	mov di, y
	shl di, 6
	mov ax, x
	shr ax, 3
	add di, ax
	xor di, 011b
	mov cx, 7
	sub cx, x
	and cx, 7
	mov al, 1
	shl al, cl
	cmp val, 1
	jne @@xblack
	or es:[di], al
	jmp @@ppupd
@@xblack:
	cmp val, 0
	je @@black
	xor es:[di], al
	jmp @@ppupd
@@black:
	not al
	and es:[di], al
@@ppupd:
	call PtrsOff
	call DeactivateArrow
	cmp Zoom, 0
	jne @@nst
	mov al, es:[di]
	mov cx, 0a000h
	mov es, cx
	mov di, y
	shl di, 2
	add di, y
	shl di, 4
	add di, 88
	mov cx, x
	shr cx, 3
	add di, cx	
	mov es:[di], al
	jmp @@ppok
@@nst:
	rol dword ptr Segs, 16
	and di, 1111111111111100b
	call SpecDraw, di
	rol dword ptr Segs, 16
@@ppok:
	call ActivateArrow
	call PtrsOn
	call ShowPtrs
@@ppdonot:
	ret

ENDP PutPoint






PROC ShowPtrs

	call DeactivateArrow
	call ShowPos, 0b03h, 3, PointerX
	call ShowPos, 0c03h, 3, PointerY
	call ShowPos, 0d03h, 3, [PointerX+2]
	call ShowPos, 0e03h, 3, [PointerY+2]
	call ActivateArrow
	ret

ENDP ShowPtrs







PROC GenNum0

	mov dword ptr GenNum, '0000'
	mov byte ptr [GenNum+4], '0'
	ret
	
ENDP GenNum0







PROC IncGenNum
USES si
	
	mov si, offset GenNum
	add si, 4
@@ignloop:
	inc byte ptr [si]
	cmp byte ptr ds:[si], '9'
	jbe @@igndone
	mov byte ptr ds:[si], '0'
	dec si
	cmp si, 0ffffh
	jne @@ignloop
@@igndone:
	ret

ENDP IncGenNum






PROC ShowGenNum

	call Write, 014ah, 5, offset GenNum
	ret

ENDP ShowGenNum






PROC MouseHandler FAR
USES es, ds, ax, bx, cx, dx, si, di

	test ax, 00010b
	jne @@bleft
	test ax, 01000b
	jne @@bright
	test ax, 00001b
	je @@mhdonot
	
	mov ax, @data
	mov ds, ax
	call MoveArrow, cx, dx
	jmp @@mhdonot
@@bleft:
	mov ax, @data
	mov ds, ax
	cmp ArrowActive, 0
	jne @@mhactive
	mov Running, 0
	jmp @@mhdonot
@@mhactive:
	call MoveArrow, cx, dx
	cmp cx, 63
	jle @@ncp
	cmp cx, 576
	jge @@ncp
	cmp dx, 0
	jle @@ncp
	cmp dx, 257
	jge @@ncp
	dec dx
	mov bx, cx
	sub bx, 64
	mov cx, Zoom
	shr bx, cl
	shr dx, cl
	add bx, ZoomDX
	add dx, ZoomDY
	call PutPoint, bx, dx, 2
	jmp @@mhdonot
@@ncp:
	cmp MenuAcc, 0
	jne @@mhdonot
	shr cx, 3
	shr dx, 4
	sub dx, 11h
	jl @@mhdonot
	sub cx, 3
	jl @@mhdonot
	cmp dx, 3
	jge @@mhdonot
	cmp cx, 70
	jge @@mharr
	mov ax, cx
	mov bx, 10
	div bl
	cmp ah, 8
	jae @@mhdonot
	and ax, 00ffh
	mov si, dx
	shl si, 2
	add si, dx
	shl dx, 1
	add si, dx
	add si, ax
	mov MenuAcc, 0ffh
	mov al, MenuChar[si]
	mov [MenuAcc+1], al
	jmp @@mhdonot
@@mharr:
	sub cx, 70
	cmp cx, 3
	jge @@mhdonot
	mov al, dl
	shl al, 2
	add al, cl
	add al, 71
	mov MenuAcc, 0ffh
	cmp al, 76
	jne @@rearr
	mov [MenuAcc+1], '?'
	jmp @@mhdonot
@@rearr:
	mov [MenuAcc+1], 0
	mov [MenuAcc+2], al
	jmp @@mhdonot
@@bright:
	mov ax, @data
	mov ds, ax
	cmp ArrowActive, 0
	jne @@mhactive2
	mov Running, 0
	jmp @@mhdonot
@@mhactive2:
	call PtrsOff
	call MoveArrow, cx, dx
	dec dx
	cmp dx, 0
	jl @@mhclr
	cmp dx, 256
	jge @@mhclr
	sub cx, 64
	jl @@mhclr
	cmp cx, 512
	jge @@mhclr
	cmp LPtr, 2
	jne @@rfst
	mov [PointerX+2], 511
	mov [PointerY+2], 255
	mov LPtr, 0
@@rfst:
	mov ax, cx
	mov cx, Zoom
	shr ax, cl
	shr dx, cl
	add ax, ZoomDX
	add dx, ZoomDY
	cmp LPtr, 0
	jne @@sec
	mov PointerX, ax
	mov PointerY, dx
	inc LPtr
	jmp @@rok
@@sec:
	mov bx, PointerX
	mov cx, PointerY
	cmp ax, bx
	jle @@ns1
	xchg ax, bx
@@ns1:
	cmp cx, dx
	jle @@ns2
	xchg cx, dx
@@ns2:
	mov PointerX, ax
	mov [PointerX+2], bx
	mov PointerY, cx
	mov [PointerY+2], dx
	inc LPtr
	jmp @@rok
@@mhclr:
	mov PointerX, 0
	mov [PointerX+2], 511
	mov PointerY, 0
	mov [PointerY+2], 255
	mov LPtr, 0
@@rok:
	call ShowPtrs
	call PtrsOn
@@mhdonot:
	ret

ENDP MouseHandler






PROC Z2Point
USES es, eax, bx, cx, dx, si, di
ARG x:word, y:word, val:word

	mov ax, 0a000h
	mov es, ax
	mov di, y
	sub di, ZoomDY
	shl di, 1
	add di, 1
	mov ax, di
	shl di, 2
	add di, ax
	shl di, 4
	mov cx, x
	sub cx, ZoomDX
	mov dx, cx
	shr dx, 2
	add di, dx ; x!
	add di, 8
	and cx, 3 ; 4-parity of x
	shl cx, 1
	mov al, 11000000b
	shr al, cl
	cmp val, 0
	jne @@zznotbl
	not al
	and es:[di], al
	and es:[di+80], al
	jmp @@zzdonot
@@zznotbl:
	or es:[di], al
	or es:[di+80], al
@@zzdonot:
	ret

ENDP Z2Point






PROC Z4Point
USES es, eax, bx, cx, dx, si, di
ARG x:word, y:word, val:word

	mov ax, 0a000h
	mov es, ax
	mov di, y
	sub di, ZoomDY
	shl di, 2
	add di, 1
	mov ax, di
	shl di, 2
	add di, ax
	shl di, 4
	mov cx, x
	sub cx, ZoomDX
	mov dx, cx
	shr dx, 1
	add di, dx ; x!
	and cx, 1 ; parity of x
	shl cx, 2
	add di, 8
	mov bx, Grid
	
	mov al, 00001111b
	rol al, cl
	mov byte ptr es:[di], 0
	and es:[di+80], al
	and es:[di+160], al
	and es:[di+240], al
	
	cmp val, 1
	jne @@zznodraw
	mov al, 01110000b
	rol al, cl
	or es:[di+80], al
	or es:[di+160], al
	or es:[di+240], al
@@zznodraw:
	cmp bx, 0
	jle @@zzdonot	
	
	mov dx, x
	and dx, bx
	cmp dx, bx
	je @@zzgrid
	mov dx, y
	and dx, bx
	cmp dx, bx
	jne @@zzdonot
@@zzgrid:
	mov al, 00100000b
	rol al, cl
	xor es:[di+160], al
@@zzdonot:
	ret

ENDP Z4Point






PROC Z8Point
USES es, eax, bx, cx, dx, si, di
ARG x:word, y:word, val:word

	mov ax, 0a000h
	mov es, ax
	xor si, si
	mov di, y
	sub di, ZoomDY
	shl di, 3
	add di, 1
	mov ax, di
	shl di, 2
	add di, ax
	shl di, 4
	mov cx, x
	sub cx, ZoomDX
	add di, cx ; x!
	add di, 8
	mov bx, Grid
	mov cx, 8
@@zzloop:
	xor al, al
	cmp val, 0
	je @@zzspace
	mov al, Z8data[si]
	inc si
@@zzspace:
	cmp bx, 0
	jle @@zzdraw
	mov dx, x
	and dx, bx
	cmp dx, bx
	je @@zzgrid
	mov dx, y
	and dx, bx
	cmp dx, bx
	jne @@zzdraw
@@zzgrid:
	cmp cx, 4
	jne @@zzdraw
	xor al, 00001000b
@@zzdraw:
	mov es:[di], al
	add di, 80
	loop @@zzloop
@@zzdonot:
	ret

ENDP Z8Point







PROC Z16Point
USES es, eax, bx, cx, dx, si, di
ARG x:word, y:word, val:word

	mov ax, 0a000h
	mov es, ax
	mov si, offset [Z16data]
	mov di, y
	sub di, ZoomDY
	shl di, 4
	add di, 1
	mov ax, di
	shl di, 2
	add di, ax
	shl di, 4
	mov cx, x
	sub cx, ZoomDX
	shl cx, 1
	add di, cx ; x!
	add di, 8
	mov bx, Grid
	mov cx, 16
@@zzloop:
	xor ax, ax
	cmp val, 0
	je @@zzspace
	mov ax, ds:[si]
	inc si
	inc si
@@zzspace:
	cmp bx, 0
	jle @@zzdraw
	mov dx, x
	and dx, bx
	cmp dx, bx
	je @@zzgrid
	mov dx, y
	and dx, bx
	cmp dx, bx
	jne @@zzdraw
@@zzgrid:
	cmp cx, 8
	jne @@zzdraw
	xor ax, 1000000000000000b
@@zzdraw:
	mov es:[di], ax
	add di, 80
	loop @@zzloop
@@zzdonot:
	ret

ENDP Z16Point






PROC ZoomIn
USES ax

	cmp Zoom, 4
	je @@zidonot
	mov ax, Zoom
	inc ax
	call SetZoom, ax
@@zidonot:
	ret

ENDP ZoomIn







PROC ZoomOut
USES ax

	cmp Zoom, 0
	je @@zodonot
	mov ax, Zoom
	dec ax
	call SetZoom, ax
@@zodonot:
	ret

ENDP ZoomOut






PROC SetZoom
USES ax, bx, cx, si, di
ARG zval:word

	call PtrsOff
	mov si, Zoom
	shl si, 1
	add si, offset ZoomSize
	mov di, zval
	shl di, 1
	add di, offset ZoomSize
	cmp si, di
	ja @@szless
	mov bx, PointerX
	add bx, [PointerX+2]
	sub bx, ds:[di]
	sar bx, 1
	mov cx, PointerY
	add cx, [PointerY+2]
	shl cx, 1
	sub cx, ds:[di]
	sar cx, 2
	jmp @@szdo
@@szless:
	mov ax, ds:[di]
	sub ax, ds:[si]
	shr ax, 1
	mov bx, ZoomDX
	sub bx, ax
	shr ax, 1
	mov cx, ZoomDY
	sub cx, ax
@@szdo:	
	mov ax, zval
	mov Zoom, ax
	mov ZoomDX, 0ffffh
	mov ZoomDY, 0ffffh
	call SetPos, bx, cx
	call PtrsOn
	ret
	
ENDP SetZoom







PROC SetGrid
USES ax
ARG grval:word

	mov ax, grval
	dec ax
	mov Grid, ax
	cmp Zoom, 1
	jbe @@sgdonot
	call UpdateScreen
@@sgdonot:
	ret
	
ENDP SetGrid







PROC SetPos
USES ax, bx, cx, dx, si, di
ARG x:word, y:word

	mov si, Zoom
	cmp si, 0
	jne @@spcont
	xor ax, ax
	xor bx, bx
	jmp @@spdo
@@spcont:
	mov cx, ZoomDX
	mov dx, ZoomDY
	shl si, 1
	add si, offset ZoomSize
	mov ax, x
	mov bx, y
	mov di, 512
	sub di, [si]
	cmp ax, 0
	jge @@sp1
	xor ax, ax
@@sp1:
	cmp bx, 0
	jge @@sp2
	xor bx, bx
@@sp2:
	cmp ax, di
	jle @@sp3
	mov ax, di
@@sp3:
	shr di, 1
	cmp bx, di
	jle @@sp4
	mov bx, di
@@sp4:
	cmp ax, cx
	jne @@spdo
	cmp bx, dx
	je @@spdonot
@@spdo:
	mov ZoomDX, ax
	mov ZoomDY, bx
	call UpdateScreen
@@spdonot:
	ret

ENDP SetPos





PROC XorIcon
USES es, ax, bx, cx, si, di
ARG addr:word, ln:word, x:word, y:word


	mov ax, 0a000h
	mov es, ax
	mov di, y
	shl di, 2
	add di, y
	shl di, 4
	mov ax, x
	shr ax, 3
	add di, ax
	mov cx, x
	and cx, 7
	mov si, addr
	mov bx, ln
@@daloop:
	mov ax, [si]
	ror ax, cl
	xor es:[di], ax
	add si, 2
	add di, 80
	sub bx, 1
	jne @@daloop
	ret

ENDP XorIcon




PROC _DrawArrow
ARG x:word, y:word

	call XorIcon, offset Arrow, 14, x, y
	ret

ENDP _DrawArrow





PROC _SPtr
USES ax, bx, cx, dx
ARG x:word, y:word

	mov cx, Zoom
	mov dx, 1
	shl dx, cl
	shr dx, 1	
	mov ax, x
	sub ax, ZoomDX
	shl ax, cl
	add ax, 60
	add ax, dx	
	mov bx, y
	sub bx, ZoomDY
	shl bx, cl
	sub bx, 4
	add bx, dx
	cmp ax, 60
	jl @@donot
	cmp ax, 60+511
	jg @@donot
	cmp bx, -4
	jl @@donot
	cmp bx, 255-4
	jg @@donot 
	call XorIcon, offset Pointer, 11, ax, bx
@@donot:
	ret

ENDP _SPtr





PROC TogglePtrs
USES ax

	cmp LPtr, 0
	je @@tpdonot
	call _SPtr, PointerX, PointerY
	cmp LPtr, 1
	je @@tpdonot
	mov ax, [PointerY+2]
	cmp ax, PointerY
	je @@t1
	call _SPtr, PointerX, ax
@@t1:
	mov ax, [PointerX+2]
	cmp ax, PointerX
	je @@tpdonot
	call _Sptr, ax, PointerY
	mov ax, [PointerY+2]
	cmp ax, PointerY
	je @@tpdonot
	call _Sptr, [PointerX+2], ax
@@tpdonot:
	ret
	
ENDP TogglePtrs




DATASEG
PTRAct dw 0
CODESEG



PROC PtrsOn

	cmp PTRAct, 0
	jne @@podonot
	cmp Running, 0
	jne @@podonot
	call TogglePtrs
	mov PTRAct, 1
@@podonot:
	ret

ENDP PtrsOn





PROC PtrsOff

	cmp PTRAct, 0
	je @@podonot
	call TogglePtrs
	mov PTRAct, 0
@@podonot:
	ret

ENDP PtrsOff







PROC MoveArrow
USES es, ax, bx, cx, dx
ARG x:word, y:word

	cmp ArrowActive, 0
	je @@madonot
	call _DrawArrow, ArrowX, ArrowY
	call _DrawArrow, x, y
	mov ax, y
	mov ArrowY, ax
	mov bx, ax
	mov ax, x
	mov ArrowX, ax
	
	sub ax, 64
	jl @@mand
	cmp ax, 512
	jge @@mand
	sub bx, 1
	jl @@mand
	cmp bx, 256
	jge @@mand
	mov cx, Zoom
	shr ax, cl
	shr bx, cl
	add ax, ZoomDX
	add bx, ZoomDY
	call ShowPos, 0d4ch, 3, ax
	call ShowPos, 0e4ch, 3, bx
	jmp @@madonot
@@mand:
	call Write, 0d4ch, 3, offset StrND
	call Write, 0e4ch, 3, offset StrND
@@madonot:
	ret

ENDP MoveArrow






PROC ActivateArrow
USES es, ax, bx, cx, dx, si, di

	cmp ArrowActive, 0
	jne @@aadonot
	cmp Running, 0
	jne @@aadonot
	mov ax, 03h
	int 33h
	mov ArrowX, cx
	mov ArrowY, dx
	call _DrawArrow, cx, dx
	mov ArrowActive, 1
	mov cx, Zoom
	mov ax, ArrowX
	sub ax, 64
	jl @@aadonot
	shr ax, cl
	add ax, ZoomDX
	mov bx, ArrowY
	sub bx, 1
	jl @@aadonot
	shr bx, cl
	add bx, ZoomDY
	cmp ax, 511
	jg @@aadonot
	cmp bx, 255
	jg @@aadonot
	call ShowPos, 0d4ch, 3, ax
	call ShowPos, 0e4ch, 3, bx
@@aadonot:
	ret

ENDP ActivateArrow






PROC DeactivateArrow
USES es, ax, bx, cx, dx, si, di

	cmp ArrowActive, 0
	je @@aadonot
	call _DrawArrow, ArrowX, ArrowY
	mov ArrowActive, 0
	
	call Write, 0d4ch, 3, offset StrND
	call Write, 0e4ch, 3, offset StrND
@@aadonot:
	ret

ENDP DeactivateArrow






PROC CopySeg
USES es, ax, cx, si, di

	cld
	push ds
	mov ax, [Segs+2]
	mov es, ax
	mov ax, Segs
	mov ds, ax
	xor si, si
	xor di, di
	mov cx, 4096
	rep movsd
	pop ds
	ret

ENDP CopySeg






DATASEG
FDWord dw ?
LDWord dw ?
RLen   dw ?
FDWValue dd ?
LDWValue dd ?
CODESEG

PROC Block
USES es, eax, bx, cx, dx, si, di
ARG value:word

	call CopySeg
	mov ax, PointerX
	shr ax, 5
	shl ax, 2
	mov FDWord, ax
	mov ax, [PointerX+2]
	shr ax, 5
	shl ax, 2
	mov LDWord, ax
	sub ax, FDWord
	je @@samedword
	dec ax
@@samedword:
	shr ax, 2
	mov RLen, ax
	mov cx, PointerX
	and cx, 31
	xor eax, eax
	stc
	rcr eax, cl
	dec eax
	mov FDWValue, eax
	mov cx, [PointerX+2]
	and cx, 31
	mov eax, 80000000h
	shr eax, cl
	dec eax
	not eax
	mov LDWValue, eax
	mov ax, FDWord
	cmp ax, LDWord
	jne @@neq
	mov eax, FDWValue
	and eax, LDWValue
	mov FDWValue, eax	
@@neq:
	mov ax, Segs
	mov es, ax
	mov dx, PointerY
@@blloop:
	mov di, dx
	shl di, 6   ; string address
	add di, FDWord
	mov eax, FDWValue
	cmp value, 2
	jne @@n1
	xor es:[di], eax
	jmp @@nn
@@n1:
	cmp value, 1
	jne @@n2
	or es:[di], eax
	jmp @@nn
@@n2:
	not eax
	and es:[di], eax
@@nn:
	add di, 4
	cmp RLen, 0
	je @@nrun
	
	mov cx, RLen
	cmp value, 2
	jne @@c1
	mov eax, 0ffffffffh
@@ccc:
	xor es:[di], eax
	add di, 4
	sub cx, 1
	jne @@ccc
	jmp @@nrun
@@c1:
	cmp value, 1
	jne @@c2
	mov eax, 0ffffffffh
	rep stosd
	jmp @@nrun
@@c2:
	xor eax, eax
	rep stosd	
	
@@nrun:
	mov ax, LDWord
	cmp ax, FDWord
	je @@thatsall
	mov eax, LDWValue
	cmp value, 2
	jne @@nx1
	xor es:[di], eax
	jmp @@thatsall
@@nx1:
	cmp value, 1
	jne @@nx2
	or es:[di], eax
	jmp @@thatsall
@@nx2:
	not eax
	and es:[di], eax
	
@@thatsall:
	inc dx	
	cmp dx, [PointerY+2]
	jle @@blloop

	call UpdateScreen
	ret
	
ENDP Block

DATASEG
Tmp db ?
CODESEG


PROC GoCommand
USES es, bx, cx, dx, si, di

	call PtrsOff
	call DeactivateArrow
	call Write, 1514h, 37, offset GoMsg
	mov dword ptr [spBuff], '    '
	mov [spBuff+4], ' '

	mov si, 1500h+58
	xor di, di
@@inloop:
	mov ax, 0700h
	int 21h
	cmp al, '0'
	jl @@nan
	cmp al, '9'
	jg @@nan
	cmp di, 4
	je @@inloop
	mov spBuff[di], al
	mov Tmp, al
	call Write, si, 1, offset Tmp
	inc di
	inc si
	jmp @@inloop
@@nan:
	cmp al, 13
	je @@ok
	cmp al, 27
	jne @@lc
	mov spBuff, ' '
	jmp @@ok
@@lc:
	cmp al, 8 ; Backspace
	jne @@inloop
	cmp di, 0
	je @@inloop
	dec di
	dec si
	mov spBuff[di], ' '
	mov Tmp, ' '
	call Write, si, 1, offset Tmp
	jmp @@inloop	
@@ok:
	call ClearInfo

	xor ax, ax
	xor di, di
@@tloop:
	cmp spBuff[di], ' '
	je @@done
	mov bx, ax
	shl bx, 2
	add ax, bx
	shl ax, 1
	xor bh, bh
	mov bl, spBuff[di]
	sub bl, '0'
	add ax, bx
	inc di
	cmp di, 4
	jne @@tloop
@@done:
	cmp ax, 0
	je @@nogo
	call Run, ax
@@nogo:
	call ActivateArrow
	call PtrsOn
	ret
	
ENDP GoCommand



; Run
; Run through LIFE until limit reached or button pressed
; In:  limit (0 is forever)
; Out: none
; Ex:  none

PROC Run
USES ax, bx, cx, dx, si, di
ARG limit:word

	mov dword ptr [EditSize], 0
	push ds
	mov ax, SegEdit
	mov es, ax
	mov ax, Segs
	mov ds, ax
	xor di, di
	xor si, si
	mov cx, 4096
	rep movsd
	pop ds
	call DeactivateArrow
	mov Running, 1
	mov dx, limit

@@runloop:
	call NextStep
	call IncGenNum
	call ShowGenNum
	cmp Change, 0
	je @@exit
	xor si, si
	xor di, di
@@inloop:
	mov ax, 0b00h
	int 21h
	cmp al, 0
	je @@noin
	mov ax, 0700h
	int 21h
	cmp al, 96
	jle @@ok
	sub al, 32
@@ok:
	cmp al, 27
	jne @@x0
	mov Running, 0
	jmp @@done
@@x0:
	cmp al, 'D'
	je @@sgd
	cmp al, '.'
	jne @@x01
@@sgd:
	cmp Grid, 0
	je @@sg
	call SetGrid, 0
	jmp @@done
@@sg:
	call SetGrid, GSize
	jmp @@done
@@x01:
	cmp al, '<'
	jne @@x02
	cmp GSize, 2
	je @@done
	shr GSize, 1
	call SetGrid, GSize
	jmp @@done
@@x02:
	cmp al, '>'
	jne @@x1
	cmp GSize, 16
	je @@done
	shl GSize, 1
	call SetGrid, GSize
	jmp @@done
@@x1:
	cmp al, '+'
	jne @@x2
	call ZoomIn
	jmp @@done
@@x2:
	cmp al, '-'
	jne @@x21
	call ZoomOut
	jmp @@done
@@x21:
	cmp al, 'V'
	jne @@x3
	call SetZoom, 0
	jmp @@done
@@x3:
	cmp al, ' '
	jne @@x4
	mov Running, 0
	jmp @@done
@@x4:
	cmp al, 'E'
	jne @@x5
	push si
	mov si, Zoom
	shl si, 1
	mov ax, 512
	sub ax, ZoomSize[si]
	shr ax, 1
	mov bx, ax
	shr bx, 1
	call SetPos, ax, bx
	pop si
	jmp @@done	
@@x5:
	cmp al, 0
	jne @@done
	
	mov ax, 0040h
	mov es, ax
	test byte ptr es:[0017h], 15
	je @@simple
	push si
	mov si, Zoom
	shl si, 1
	mov cx, ZoomSize[si]
	mov bx, ZoomSize[si]
	shr bx, 1
	pop si
	jmp @@gogo
@@simple:
	mov cx, 1
	mov bx, 1
@@gogo:	
	mov ax, 0700h
	int 21h
	cmp al, 72
	jne @@r1
	sub di, bx
	jmp @@done
@@r1:
	cmp al, 80
	jne @@r2
	add di, bx
	jmp @@done
@@r2:
	cmp al, 75
	jne @@r3
	sub si, cx
	jmp @@done
@@r3:
	cmp al, 77
	jne @@r4
	add si, cx
	jmp @@done
@@r4:
	cmp al, 71
	jne @@r5
	sub si, cx
	sub di, bx
	jmp @@done
@@r5:
	cmp al, 79
	jne @@r6
	add di, bx
	sub si, cx
	jmp @@done
@@r6:
	cmp al, 81
	jne @@r7
	add di, bx
	add si, cx
	jmp @@done
@@r7:
	cmp al, 73
	jne @@done
	sub di, bx
	add si, cx
@@done:
	jmp @@inloop
@@noin:	
	cmp si, 0
	jne @@set
	cmp di, 0
	je @@noset
@@set:
	mov ax, ZoomDX
	add ax, si
	mov bx, ZoomDY
	add bx, di
	call SetPos, ax, bx
@@noset:
	cmp Running, 1
	jne @@exit
	cmp dx, 0
	je @@runloop
	sub dx, 1
	jne @@runloop
@@exit:
	mov Running, 0
	call ActivateArrow
	push ds
	mov ax, [Segs+2]
	mov es, ax
	mov ax, SegEdit
	mov ds, ax
	xor di, di
	xor si, si
	mov cx, 4096
	rep movsd
	pop ds
	ret

ENDP Run





PROC ClearInfo
USES es, ax, cx, di
	
	mov ax, 0a000h
	mov es, ax
	cld
	mov di, 80*21*16
	mov cx, 80*16
	rep stosb
	ret
	
ENDP ClearInfo





PROC CopyToSeg
USES es, eax, bx, cx, edx, si, di
ARG segaddr:word

	mov cx, 4096
	xor eax, eax
	mov bx, segaddr
	mov es, bx
	xor di, di
	cld
	rep stosd
	mov cx, [PointerX+2]
	sub cx, PointerX
	inc cx
	test cx, 31
	jne @@tok
	shr cx, 5
	jmp @@tok2
@@tok:
	shr cx, 5
	add cx, 1
@@tok2:
	mov bx, [PointerY+2]
	sub bx, PointerY
	inc bx
	xor di, di
	mov si, PointerY
	shl si, 6
	mov dx, PointerX
	shr dx, 5
	shl dx, 2
	add si, dx
; cx = len
; bx = str count
; si, di set
	mov ax, segaddr
	mov es, ax
	push ds
	push bp
	mov bp, PointerX
	and bp, 31

	mov ax, Segs
	mov ds, ax
@@ctloop:
	push cx
	push di
	push si
@@dloop:
	mov edx, ds:[si]
	cmp si, 16380
	jne @@secw
	mov eax, es:[0]
	jmp @@ssw
@@secw:
	mov eax, ds:[si+4]
@@ssw:
	push cx
	mov cx, bp
	shld edx, eax, cl
	pop cx
	rol edx, 8
	xchg dh, dl
	rol edx, 16
	xchg dh, dl
	rol edx, 8
	mov es:[di], edx 	
	add di, 4
	add si, 4
	sub cx, 1
	jne @@dloop
	pop si
	pop di
	pop cx
	add di, 64
	add si, 64
	sub bx, 1
	jne @@ctloop
	
	pop bp
	pop ds
	ret

ENDP CopyToSeg




DATASEG
Last dw ?
Flg dw ?
CODESEG

PROC CopyFromSeg
USES es, eax, ebx, ecx, edx, si, di
ARG segaddr:word, xsize:word, ysize:word, orop:word

	mov ax, PointerX
	mov cx, xsize
	add ax, cx
	dec ax
	mov Last, ax
	test cx, 31
	jne @@tok
	shr cx, 5
	jmp @@tok2
@@tok:
	shr cx, 5
	inc cx
@@tok2:
	test PointerX, 31
	je @@tok3
	inc cx
@@tok3:
	mov bx, ysize
	xor si, si
	mov di, PointerY
	shl di, 6
	mov dx, PointerX
	shr dx, 5
	shl dx, 2
	add di, dx
; cx = len
; bx = str count
; si, di set
	mov ax, segaddr
	mov es, ax
	push ds
	mov dx, orop
	push bp
	mov bp, PointerX
	and bp, 31
	cmp dx, 0
	je @@ctloop
	or bp, 0100h
@@ctloop:
	mov Flg, 0
	push bx
	push cx
	push di
	push si
@@dloop:
	push cx
	mov edx, es:[si]
	rol edx, 8
	xchg dh, dl
	rol edx, 16
	xchg dh, dl
	rol edx, 8
	cmp si, 0
	jne @@secw
	mov eax, es:[16380]
	jmp @@ssw
@@secw:
	mov eax, es:[si-4]
	rol eax, 8
	xchg ah, al
	rol eax, 16
	xchg ah, al
	rol eax, 8
@@ssw:
	mov cx, bp
	shrd edx, eax, cl
	push di
	and di, 111100b ; > 64 ?!
	or di, Flg
	test si, 63
	jne @@notinthis
	mov eax, 0ffffffffh
	shr eax, cl
	jmp @@firstdone
@@notinthis:
	mov eax, 0ffffffffh
@@firstdone:
	mov bx, Last
	shr bx, 3
	and bx, 1111100b ; > 64 ?!
	cmp bx, di
	jge @@do2
	xor ebx, ebx
	jmp @@secdone
@@do2:
	jne @@noendthis
	mov ebx, 80000000h
	mov cx, Last
	sar ebx, cl
	jmp @@secdone
@@noendthis:
	mov ebx, 0ffffffffh
@@secdone:
	pop di
	and eax, ebx
	push ds
	push Segs
	pop ds
	and edx, eax
	test bp, 0100h
	jne @@prodor
	and edx, eax
	not eax
	and ds:[di], eax
@@prodor:
	or ds:[di], edx 	
	pop ds
	add di, 4
	and di, 16383
	test di, 63
	jne @@nnl
	mov Flg, 64
@@nnl:
	add si, 4
	pop cx
	sub cx, 1
	jne @@dloop
	pop si
	pop di
	pop cx
	add di, 64
	and di, 16383
	add si, 64
	pop bx
	sub bx, 1
	jne @@ctloop
	
	pop bp
	pop ds
	call UpdateScreen
	ret

ENDP CopyFromSeg





PROC Copy
USES ax, bx

	mov ax, [PointerX+2]
	sub ax, PointerX
	inc ax
	mov EditSize, ax
	mov bx, [PointerY+2]
	sub bx, PointerY
	inc bx
	mov [EditSize+2], bx
	call CopyToSeg, SegEdit
	ret
	
ENDP Copy




PROC Paste

	call CopySeg
	call CopyFromSeg, SegEdit, EditSize, [EditSize+2], 0	
	ret

ENDP Paste





DATASEG
FileMask db '*.', 0
FCount dw ?
CFile dw ?
CPage dw ?
CODESEG

PROC GetDir

; Cleaning LSeg

	mov ax, LSeg
	mov es, ax
	mov cx, 4096
	mov di, 0
	mov eax, '    '
	rep stosd

; Setting DTA to RSeg

	push ds
	mov ax, RSeg
	mov ds, ax
	mov es, ax
	mov ax, 1a00h
	xor dx, dx
	int 21h
	pop ds

; Reading directory for "*." to LSeg

	mov FCount, 0
	mov cx, 0
	mov dx, offset FileMask
	mov ax, 4e00h
	int 21h
	jc @@exit
@@floop:
	mov di, FCount
	shl di, 4
	push ds
	mov ax, LSeg
	mov ds, ax
	mov eax, dword ptr es:[30]
	mov dword ptr ds:[di], eax
	mov eax, dword ptr es:[34]
	mov dword ptr ds:[di+4], eax
	pop ds
	inc FCount
	cmp FCount, 1024
	je @@exit
	mov ax, 4f00h
	int 21h
	jnc @@floop
@@exit:
	ret

ENDP GetDir




PROC Hilight
	
	mov ax, 0a000h
	mov es, ax
	mov ax, CFile
@@lkl:
	cmp ax, 72
	jl @@cont
	sub ax, 72
	jmp @@lkl
@@cont:
	mov bx, 12
	div bl
	mov bl, ah   ; line
	add bx, 1
	shl bx, 4    
	mov dx, bx
	shl bx, 2
	add bx, dx
	shl bx, 4
	and ax, 0ffh ; col
	inc ax
	mov dx, ax
	shl ax, 2
	add ax, dx
	shl ax, 1
	inc ax       ; real col addr
	add bx, ax   ; real scr addr
	mov si, 14
@@xorloop:
	mov cx, 8
	mov di, bx
@@xloop:
	xor byte ptr es:[di], 0ffh
	inc di
	sub cx, 1
	jne @@xloop
	add bx, 80
	sub si, 1
	jne @@xorloop	
	ret
	
ENDP Hilight




PROC ShowFPage
ARG pagereq:word

	mov ax, pagereq
	cmp ax, CPage
	je @@exit
	mov CPage, ax
	call Write, 0e18h, 32, offset SelectMsg
	mov si, 0
@@mloop:	  ; Finding first file on page
	cmp ax, 0
	je @@cont
	add si, 72*16
	dec ax
	jmp @@mloop
@@cont:
	mov ax, LSeg
	mov es, ax ; address in es:[si] 	
	mov ax, 1  ; line
	mov bx, 11 ; column
	push bp
	mov bp, si
@@outloop:
	push ax
@@outloopi:
	push ax
	push bx
	push bp
	mov dx, ax
	shl dx, 8
	add dx, bx
	mov bx, 000fh
	mov cx, 8
	mov ax, 1300h
	int 10h
	pop bp
	add bp, 16
	pop bx
	pop ax
	inc ax
	cmp ax, 13
	jl @@outloopi
	pop ax
	add bx, 10
	cmp bx, 71
	jl @@outloop
	pop bp
@@exit:
	ret

ENDP ShowFPage




PROC Select

	mov dx, 256
	mov ax, 0a000h
	mov es, ax
	mov di, 88
@@llp:
	push di
	mov cx, 16
	mov eax, 0
	rep stosd
	pop di
	add di, 80
	sub dx, 1
	jne @@llp
	
	mov CPage, -1
	call ShowFPage, 0
	mov CFile, 0
	call Hilight
@@inloop:
	mov ax, 0700h
	int 21h
	cmp al, 27
	jne @@s1
	mov FName, 0
	jmp @@exit
@@s1:
	cmp al, 13
	jne @@s2
	mov di, CFile
	shl di, 4
	mov ax, LSeg
	mov es, ax
	mov eax, dword ptr es:[di]
	mov dword ptr FName, eax
	mov eax, dword ptr es:[di+4]
	mov dword ptr [FName+4], eax
	mov [FName+8], 0
	jmp @@exit
@@s2:
	cmp al, 0
	jne @@inloop
	call Hilight
	mov ax, 0700h
	int 21h
	cmp al, 72
	jne @@s3
	dec CFile
	jmp @@done
@@s3:
	cmp al, 75
	jne @@s4
	sub CFile, 12
	jmp @@done
@@s4:
	cmp al, 77
	jne @@s5
	add CFile, 12
	jmp @@done
@@s5:
	cmp al, 80
	jne @@s6
	inc CFile
	jmp @@done
@@s6:
	cmp al, 73
	jne @@s7
	sub CFile, 72
	jmp @@done
@@s7:
	cmp al, 81
	jne @@inloop
	add CFile, 72
	jmp @@done
@@done:
	cmp CFile, 0
	jge @@s100
	mov CFile, 0
@@s100:
	mov ax, FCount
	cmp CFile, ax
	jl @@s101
	dec ax
	mov CFile, ax
@@s101:
	mov ax, CFile
	mov dx, 0
	mov bx, 72
	div bx
	call ShowFPage, ax
	call Hilight	
	jmp @@inloop
@@exit:
	call UpdateScreen
	ret

ENDP Select




PROC GetFileName

	mov dword ptr [FName], 0
	mov dword ptr [FName+4], 0
	mov [FName+8], 0

	mov si, 152eh
	xor di, di
@@inloop:
	mov ax, 0700h
	int 21h
	cmp al, 'a'
	jb @@ucok
	sub al, 32
@@ucok:
	cmp al, 33
	jb @@nan
	cmp al, 96
	ja @@nan
	cmp di, 8
	je @@inloop
	mov FName[di], al
	mov Tmp, al
	call Write, si, 1, offset Tmp
	inc di
	inc si
	jmp @@inloop
@@nan:
	cmp al, 13
	je @@ok
	cmp al, 27
	jne @@lc
	mov FName, 0
	jmp @@ok
@@lc:
	cmp al, 8 ; Backspace
	jne @@inloop
	cmp di, 0
	je @@inloop
	dec di
	dec si
	mov FName[di], 0
	mov Tmp, ' '
	call Write, si, 1, offset Tmp
	jmp @@inloop	
@@ok:
	cmp di, 0
	jne @@namegot
	call GetDir
	call Select
@@namegot:
	call ClearInfo
	ret
	
ENDP GetFileName




PROC SayError
USES ax

	call Write, 1513h, 42, offset FileError
	call GetYN, 0
	call ClearInfo
	ret

ENDP SayError



PROC SayNoFile
USES ax

	call Write, 1515h, 37, offset NoFile
	call GetYN
	call ClearInfo
	ret

ENDP SayNoFile





DATASEG
Handle dw ?
CODESEG


PROC Load
USES eax, bx, cx, dx, si, di

	call Write, 1519h, 19, offset LoadMsg
	call GetFileName
	call ClearInfo

	cmp FName, 0
	je @@exit
	
	mov ax, 3d00h
	lea dx, FName
	int 21h
	jc @@notex
	mov Handle, ax	

	mov ah, 3fh
	mov bx, Handle
	mov cx, 4
	mov dx, offset FName
	int 21h
	jnc @@c0
	jmp @@cloerr
@@c0:
	cmp dword ptr FName, 'EFIL'
	jne @@nfile
	
	mov ah, 3fh
	mov bx, Handle
	mov cx, 4
	mov dx, offset IOSize
	int 21h
	jnc @@c1
	jmp @@cloerr
@@c1:
	mov cx, IOSize
	shr cx, 3
	test IOSize, 7
	je @@en
	inc cx
@@en:
	mov si, [IOSize+2]
	mov bx, Handle
	mov ax, RSeg
	mov ds, ax
	xor dx, dx
@@sloop:
	mov ah, 3fh
	int 21h
	jc @@cloerr
	add dx, 64
	sub si, 1
	jne @@sloop
	mov ax, @data
	mov ds, ax
	
	mov bx, Handle
	mov ah, 3eh
	int 21h
	jmp @@done
@@cloerr:
	mov ax, @data
	mov ds, ax
	mov bx, Handle
	mov ah, 3eh
	int 21h
@@ferror:
	call SayError
	jmp @@exit
@@nfile:
	mov ax, @data
	mov ds, ax
	mov bx, Handle
	mov ah, 3eh
	int 21h
@@notex:
	call SayNoFile
	jmp @@exit
@@done:

	call CopySeg
	call Write, 1518h, 33, offset LoadTp
	call GetYN, 'MR'
	cmp ax, 1
	je @@merge
@@repl:
	call CopyFromSeg, RSeg, IOSize, [IOSize+2], 0
	jmp @@exit
@@merge:
	call CopyFromSeg, RSeg, IOSize, [IOSize+2], 1
@@exit:
	call ClearInfo
	ret
	
ENDP Load




PROC Save
USES es, ax, bx, cx, dx, si, di

	call FFCopy

	call Write, 1519h, 19, offset SaveMsg
	call GetFileName
	call ClearInfo
	
	cmp FName, 0
	je @@exit

	mov ax, 3c01h
	xor cx, cx
	lea dx, FName
	int 21h
	jc @@ferror
	mov Handle, ax	

	mov dword ptr FName, 'EFIL'
	
	mov ah, 40h
	mov bx, Handle
	mov cx, 4
	mov dx, offset FName
	int 21h
	jnc @@c0
	jmp @@cloerr
@@c0:
	mov ah, 40h
	mov bx, Handle
	mov cx, 4
	mov dx, offset IOSize
	int 21h
	jnc @@c1
	jmp @@cloerr
@@c1:

	mov cx, IOSize
	shr cx, 3
	test IOSize, 7
	je @@en
	inc cx
@@en:
	mov si, [IOSize+2]
	mov bx, Handle
	mov ax, RSeg
	mov ds, ax
	xor dx, dx
@@sloop:
	mov ah, 40h
	int 21h
	jc @@cloerr
	add dx, 64
	sub si, 1
	jne @@sloop
	mov ax, @data
	mov ds, ax
	
	mov bx, Handle
	mov ah, 3eh
	int 21h
	jmp @@exit
@@cloerr:
	mov ax, @data
	mov ds, ax
	mov bx, Handle
	mov ah, 3eh
	int 21h
@@ferror:
	call SayError
@@exit:
	ret

ENDP Save





PROC FFCopy
USES ax, bx

	mov ax, [PointerX+2]
	sub ax, PointerX
	inc ax
	mov IOSize, ax
	mov bx, [PointerY+2]
	sub bx, PointerY
	inc bx
	mov [IOSize+2], bx
	call CopyToSeg, RSeg
	ret
	
ENDP FFCopy




PROC FFPaste

	call CopySeg
	call CopyFromSeg, RSeg, IOSize, [IOSize+2], 0	
	ret

ENDP FFPaste




PROC EqSeg
USES es, eax, cx, si, di

	push ds
	mov ax, LSeg
	mov es, ax
	xor di, di
	xor si, si
	mov cx, 4096
	mov ax, RSeg
	mov ds, ax
	rep movsd
	mov ax, ds
	mov es, ax
	xor di, di
	mov cx, 4096
	xor eax, eax
	rep stosd
	pop ds
	ret

ENDP EqSeg




PROC Flip
USES es, eax, ebx, ecx, edx, si, di

	call FFCopy
	call EqSeg
	; LSeg -> RSeg flipped

	push ds
	mov cx, IOSize     ; pel counter
	xor si, si         ; pointers
	mov di, cx
	dec di
	shr di, 3
	and di, 60
	mov dx, [IOSize+2] ; line counter
	mov eax, 31	   ; source shifter
	mov bx, cx
	dec bx
	and ebx, 31
	xor bx, 31	   ; dest shifter
	push RSeg
	pop es	           ; destination
	push LSeg
	pop ds		   ; source
@@lineloop:
	push cx
	push di
	push si
	push ebx
@@pelloop:
	xor eax, 24
	xor ebx, 24
	bt ds:[si], eax
	jnc @@nojob
	bts es:[di], ebx
@@nojob:
	xor eax, 24
	xor ebx, 24
	sub eax, 1
	jae @@c1
	mov eax, 31
	add si, 4
@@c1:
	inc ebx
	cmp ebx, 32
	jne @@c2
	mov ebx, 0
	sub di, 4
@@c2:
	sub cx, 1
	jne @@pelloop
	
	pop ebx
	mov eax, 31
	pop si
	pop di
	pop cx
	add si, 64
	add di, 64
	sub dx, 1
	jne @@lineloop

	pop ds
	call FFPaste
	ret
	
ENDP Flip





PROC Flop
USES es, eax, bx, cx, edx, si, di

	call FFCopy
	call EqSeg

	mov bx, [IOSize+2]
	mov di, bx
	dec di
	shl di, 6
	mov si, 0
	mov cx, IOSize
	add cx, 31
	shr cx, 5

	push ds
	mov si, 0
	mov ax, RSeg
	mov es, ax
	mov ax, LSeg
	mov ds, ax
@@loopy:
	push cx
	push si
	push di
	rep movsd
	pop di
	pop si
	pop cx
	add si, 64
	sub di, 64
	sub bx, 1
	jne @@loopy	
	pop ds
	call FFPaste
	ret
	
ENDP Flop





PROC Rotate

	call FFCopy
	call EqSeg

	push ds
	mov cx, IOSize     ; pel counter
	xor si, si         ; pointers
	mov dx, [IOSize+2] ; line counter
	mov di, dx
	dec di
	shr di, 3
	and di, 60
	mov eax, 31	   ; source shifter
	mov bx, dx
	dec bx
	and ebx, 31
	xor bx, 31	   ; dest shifter
	push RSeg
	pop es	           ; destination
	push LSeg
	pop ds		   ; source
@@lineloop:
	push cx
	push di
	push si
@@pelloop:
	xor eax, 24
	xor ebx, 24
	bt ds:[si], eax
	jnc @@nojob
	bts es:[di], ebx
@@nojob:
	xor eax, 24
	xor ebx, 24
	sub eax, 1
	jae @@c1
	mov eax, 31
	add si, 4
@@c1:
	add di, 64
	and di, 16383

	sub cx, 1
	jne @@pelloop
	
	mov eax, 31
	pop si
	pop di
	pop cx

	inc ebx
	cmp ebx, 32
	jne @@c2
	mov ebx, 0
	sub di, 4
@@c2:
	add si, 64
	sub dx, 1
	jne @@lineloop

	pop ds

	call TogglePtrs	
	rol dword ptr IOSize, 16
	cmp [IOSize+2], 256
	jle @@yok
	mov [IOSize+2], 256
@@yok:
	mov ax, PointerX
	add ax, IOSize
	dec ax
	cmp ax, 512
	jle @@xpok
	mov ax, 512
@@xpok:
	mov [PointerX+2], ax
	mov ax, PointerY
	add ax, [IOSize+2]
	dec ax
	cmp ax, 256
	jl @@ypok
	mov ax, 255
@@ypok:
	mov [PointerY+2], ax
	mov LPtr, 2
	call TogglePtrs
	call DeactivateArrow
	call ShowPtrs

	call FFPaste
	ret
	
ENDP Rotate





PROC Count
USES es, eax, ebx, ecx, dx, di

	call DeactivateArrow
	call Write, 151ch, 17, offset CntMsg
	mov ax, Segs
	mov es, ax
	xor eax, eax
	mov di, 16380
@@loop:
	mov ebx, es:[di]
	mov ecx, 31
@@iloop:
	bt ebx, ecx
	adc eax, 0
	sub cx, 1
	jge @@iloop
	sub di, 4
	jge @@loop	
	call ShowDWord, 152eh, 6, eax
	call GetYN, 0
	call ClearInfo
	call ActivateArrow
	ret

ENDP Count




PROC GetYN
USES bx, cx, dx
ARG yn:word

@@moa:
	mov ax, 0003h
	int 33h
	test bx, 3
	jne @@moa
@@loop:
	mov ax, 0003h
	int 33h
	test bx, 1
	je @@nl
	mov ax, 1
	jmp @@exit
@@nl:
	test bx, 2
	je @@nm
	xor ax, ax
	jmp @@exit
@@nm:
	mov ax, 0b00h
	int 21h
	cmp al, 0
	je @@loop
	mov ax, 0700h
	int 21h
	jne @@got
	mov ax, 0700h
	int 21h
@@got:
	cmp yn, 0
	je @@exit
	cmp al, 'a'
	jb @@proc
	sub al, 32
@@proc:
	cmp al, 13
	je @@yes
	cmp al, 27
	je @@no
	mov bx, yn
	cmp al, bh
	jne @@ny
@@yes:
	mov ax, 1
	jmp @@exit
@@ny:
	cmp al, bl
	jne @@loop
@@no:
	xor ax, ax
@@exit:
	ret

ENDP GetYN




PROC Start
	
@@gloop:
	cmp MenuAcc, 0fh
	jne @@cont
	mov MenuAcc, 0
	jmp @@gloop
@@cont:
	cmp MenuAcc, 0ffh
	jne @@keyin
	mov al, [MenuAcc+1]
	mov MenuAcc, 0fh
	jmp @@ok
@@keyin:
	mov ax, 0b00h
	int 21h
	cmp al, 0
	je @@gloop
	
	mov ax, 0700h
	int 21h
	cmp al, 96
	jle @@ok
	sub al, 32
@@ok:
	cmp al, 'R'
	je @@srs
	cmp al, ' '
	jne @@s1
@@srs:
	call PtrsOff
	call Run, 0
	call PtrsOn
	jmp @@gloop
@@s1:
	cmp al, 'G'
	jne @@s2
	call GoCommand
	jmp @@gloop
@@s2:
	cmp al, 'N'
	jne @@s3
	call PtrsOff
	call DeactivateArrow
	mov Running, 1
	call NextStep
	mov Running, 0
	call IncGenNum
	call ShowGenNum
	call ActivateArrow
	call PtrsOn
	jmp @@gloop
@@s3:
	cmp al, '+'
	jne @@s4
	call ZoomIn
	jmp @@gloop
@@s4:
	cmp al, '-'
	jne @@s5
	call ZoomOut
	jmp @@gloop
@@s5:
	cmp al, 'V'
	jne @@s6
	call SetZoom, 0
	jmp @@gloop
@@s6:
	cmp al, 'D'
	je @@sgd
	cmp al, '.'
	jne @@s61
@@sgd:
	cmp Grid, 0
	jle @@sg
	call SetGrid, 0
	jmp @@gloop
@@sg:
	call SetGrid, 8
	jmp @@gloop
@@s61:
	cmp al, '<'
	jne @@s62
	cmp GSize, 2
	je @@gloop
	shr GSize, 1
	call SetGrid, GSize
	jmp @@gloop
@@s62:
	cmp al, '>'
	jne @@s7
	cmp GSize, 16
	je @@gloop
	shl GSize, 1
	call SetGrid, GSize
	jmp @@gloop
@@s7:
	cmp al, '0'
	jne @@s8
	call GenNum0
	call ShowGenNum
	jmp @@gloop
@@s8:
	cmp al, 'E'
	jne @@s9
	mov si, Zoom
	shl si, 1
	mov ax, 512
	sub ax, ZoomSize[si]
	shr ax, 1
	mov bx, ax
	shr bx, 1
	call SetPos, ax, bx
	jmp @@gloop
@@s9:
	cmp al, 'Z'
	jne @@s10
	call Block, 0
	jmp @@gloop
@@s10:
	cmp al, 'F'
	jne @@s11
	call Block, 1
	jmp @@gloop
@@s11:
	cmp al, 'I'
	jne @@s111
	call Block, 2
	jmp @@gloop
@@s111:
	cmp al, 'U'
	jne @@s112
	rol dword ptr Segs, 16
	call UpdateScreen
	jmp @@gloop
@@s112:
	cmp al, 'C'
	jne @@s113
	call Copy
	jmp @@gloop
@@s113:
	cmp al, 'P'
	jne @@s114
	call Paste
	jmp @@gloop
@@s114:
	cmp al, '='
	jne @@s115
	call Flip
	jmp @@gloop
@@s115:
	cmp al, '|'
	je @@sf
	cmp al, '\'
	jne @@s116
@@sf:
	call Flop
	jmp @@gloop
@@s116:
	cmp al, '*'
	jne @@s12
	call Rotate
	jmp @@gloop	
@@s12:
	cmp al, 'S'
	jne @@s13
	call DeactivateArrow
	call Save
	call ActivateArrow
	jmp @@gloop
@@s13:
	cmp al, 'L'
	jne @@s131
	call DeactivateArrow
	call Load
	call ActivateArrow
	jmp @@gloop
@@s131:
	cmp al, '?'
	jne @@s14
	call Count
	jmp @@gloop
@@s14:
	cmp al, 'X'
	je @@exit
	cmp al, 27
	je @@exit
	
	cmp al, 0
	jne @@gloop
	
	mov ax, 0040h
	mov es, ax
	test byte ptr es:[0017h], 15
	je @@simple
	mov si, Zoom
	shl si, 1
	mov cx, ZoomSize[si]
	mov bx, ZoomSize[si]
	shr bx, 1
	jmp @@gogo
@@simple:
	mov cx, 1
	mov bx, 1
@@gogo:	
	xor di, di
	xor si, si
	cmp MenuAcc, 0fh
	jne @@key2
	mov al, [MenuAcc+2]		
	jmp @@ok2
@@key2:
	mov ax, 0700h
	int 21h
@@ok2:
	cmp al, 72
	jne @@r1
	sub di, bx
	jmp @@set
@@r1:
	cmp al, 80
	jne @@r2
	add di, bx
	jmp @@set
@@r2:
	cmp al, 75
	jne @@r3
	sub si, cx
	jmp @@set
@@r3:
	cmp al, 77
	jne @@r4
	add si, cx
	jmp @@set
@@r4:
	cmp al, 71
	jne @@r5
	sub si, cx
	sub di, bx
	jmp @@set
@@r5:
	cmp al, 79
	jne @@r6
	add di, bx
	sub si, cx
	jmp @@set
@@r6:
	cmp al, 81
	jne @@r7
	add di, bx
	add si, cx
	jmp @@set
@@r7:
	cmp al, 73
	jne @@gloop
	sub di, bx
	add si, cx
@@set:
	mov ax, ZoomDX
	add ax, si
	mov bx, ZoomDY
	add bx, di
	call SetPos, ax, bx
	jmp @@gloop

@@exit:	
	call DeactivateArrow
	call Write, 1507h, 65, offset QuitMsg
	call GetYN, 'YN'
	cmp ax, 1
	je @@okex
@@noex:
	call ClearInfo
	call ActivateArrow
	jmp @@gloop
@@okex:
	ret

ENDP Start

	END